<div class="container-m--x bredcrumb admin-bg" style="margin-top:-11.9px;">
    <div class="row px-4 f-16 white">
       <div class="col-md-4">
          <span (click)="goToDefaultPage()" class="cursor"><i class="las la-home f-18 "></i></span>
          <span class="px-3"><i class="las la-angle-right f-12 "></i></span>
          <span class="font-weight-normal">Administration</span>
       </div>
    </div>
  </div>
<div >
    <!-- <div class="row mt-2">

        <div class="col-md-10">
            <form class="form-inline">
                <div class="form-group">
                    <label>
                        <h3 class="card-title-material mb-0">Role List</h3>
                    </label>

                    <input style="width: 80vw; max-width: calc(80vw - 150px); margin-left: 15px;"
                        class="form-control user-input-material" type='text' placeholder='Search'
                        (keyup)='updateFilter($event)'>
                </div>
            </form>
        </div>

        <div class="col-md-2">
            <button class="btn btn-md btn-primary pull-right"
                (click)="openDialog(addRolesModal, { windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false })">
                <span class="fa fa-plus"></span> Add New Role</button>
        </div>
        <div class="col-md-12 p-0">
            <hr class="hr-border container-m--x mt-3 mb-3">
        </div>
    </div> -->
    <div>
        <div class="content">
            <div class="content_width">
                <div class="row">
                    <div class="col-md-3 sidebar_top">
                    <admin-sidebar></admin-sidebar>
                    </div>
                    <div class="col-md-9 card_title_top">
                            <label>
                                <h2 class="card-title-material">Role List</h2>
                            </label>
                            <div class="table-wrapper mt-2">
                                <div class="row">
                                    <div class="search-box">
                                        <div class="input-group">
                                            <span class="input-group-addon input_group_margin"><i class="las la-search fa-lg search_icon_transform"></i>
                                            </span>
                            <input type="text" id="search" class="form-control search_input search_bg" type='search' placeholder='Search'
                            (keyup)='updateFilter($event)'>
    </div>
    </div>
    <div class="add_user_ctn">
                                        <!-- <button class="btn btn-md btn-primary pull-right" (click)="navigateToAddNewRole()">  -->
                                                 <button class="btn btn-md btn-primary pull-right"
                                                (click)="openDialog(addRolesModal, { windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false })">
                                                <span class="fa fa-plus"></span> Add New Role</button>
                                    </div>
                                    </div>
                                    <div *ngIf="!detectmob()" class="card-ngx-datatable table-responsive">
                                        <ngx-datatable #table style="min-width: 550px" [rows]="rows" [loadingIndicator]="loadingIndicator"
                                            [columnMode]="'force'" [headerHeight]="33" [footerHeight]="'auto'" [rowHeight]="'auto'"
                                            [reorderable]="true" [limit]="10">
                            
                                            <ngx-datatable-column name="Role" [width]="250">
                            
                                            </ngx-datatable-column>
                                            <!-- <ngx-datatable-column name="Entities">
                            
                                        </ngx-datatable-column> -->
                                            <ngx-datatable-column name="Entities" [width]="400">
                                                <ng-template let-column="column" ngx-datatable-header-template>
                                                    Entities
                                                </ng-template>
                                                <ng-template let-row="row" let-value="value"  ngx-datatable-cell-template>
                                                    <div class="badge badge-default ml-0 p-2 m-1 bgOverwrite" *ngFor="let e of value">{{e.description}}</div>
                                                </ng-template>
                                            </ngx-datatable-column>
                                            <ngx-datatable-column name="Description" [width]="300">
                            
                                            </ngx-datatable-column>
                                            <ngx-datatable-column name="opt" [width]="200">
                                                <ng-template let-column="column" ngx-datatable-header-template>
                                                    Action
                                                </ng-template>
                                                <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                                    <button class="btn custom-icon-btn btn-sm btn-outline-info  borderless"
                                                        placement="top" ngbTooltip="Edit"
                                                        (click)="edit(row['role'],row['description'],row['entities'],editModal,{ windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false },value)"
                                                        [disabled]="row['opt']=='false'" style="background: none;
                                                        color: black !important;">
                                                        <i class="fa-lg las la-edit"></i>
                                                    </button>
                                                    <button class="btn custom-icon-btn btn-sm btn-outline-danger  borderless"
                                                        placement="top" ngbTooltip="Delete"
                                                        (click)="checkRoleAssigned(row['role'],row['description'],row['entities'],deleteModal,{ windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false},value)"
                                                        [disabled]="row['opt']=='false'" style="background: none;
                                                        color: black;">
                                                        <i class="fa-lg las la-trash"></i>
                                                    </button>
                                                </ng-template>
                                            </ngx-datatable-column>
                            
                                        </ngx-datatable>
                                    </div>
                                    <div *ngIf="detectmob()" class="card-ngx-datatable table-responsive">
                                        <ngx-datatable #table style="min-width: 30vh" [scrollbarH]="scrollBarHorizontal" [rows]="rows" [loadingIndicator]="loadingIndicator"
                                            [columnMode]="'force'" [headerHeight]="33" [footerHeight]="'auto'" [rowHeight]="'auto'"
                                            [reorderable]="true" [limit]="10">
                            
                                            <ngx-datatable-column name="Role"  [width]="100"> 
                            
                                            </ngx-datatable-column>
                                            <ngx-datatable-column name="Entities" [minWidth]="150">
                                                <ng-template let-column="column" ngx-datatable-header-template>
                                                    Entities
                                                </ng-template>
                                                <ng-template let-row="row" let-value="value"  ngx-datatable-cell-template>
                                                    <div class="badge badge-default ml-0 p-2 m-1 bgOverwrite" *ngFor="let e of value">{{e.description}}</div>
                                                </ng-template>
                                            </ngx-datatable-column>
                                            <ngx-datatable-column name="Description"  [width]="50">
                            
                                            </ngx-datatable-column>
                                            <ngx-datatable-column name="opt" [width]="50">
                                                <ng-template let-column="column" ngx-datatable-header-template>
                                                    Action
                                                </ng-template>
                                                <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                                                    <button class="btn custom-icon-btn btn-sm btn-outline-info  borderless"
                                                        placement="top" ngbTooltip="Edit"
                                                        (click)="edit(row['role'],row['description'],row['entities'],editModal,{ windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false },value)"
                                                        [disabled]="row['opt']=='false'" style="background: none;
                                                        color: black !important;">
                                                        <i class="fa-lg las la-edit"></i>
                                                    </button>
                                                    <button class="btn custom-icon-btn btn-sm btn-outline-danger  borderless"
                                                        placement="top" ngbTooltip="Delete"
                                                        (click)="checkRoleAssigned(row['role'],row['description'],row['entities'],deleteModal,{ windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false},value)"
                                                        [disabled]="row['opt']=='false'" style="background: none;
                                                        color: black;">
                                                        <i class="fa-lg las la-trash"></i>
                                                    </button>
                                                </ng-template>
                                            </ngx-datatable-column>
                            
                                        </ngx-datatable>
                                    </div>
                                    </div>
            
                        </div>
                            
                    </div>
                </div>

            <!-- <div class="row col justify-content-md-left">
                <div class="col-md-2 align-middle">
                    <h3 class="card-title-material mt-2">Role List</h3>
                </div>
                <div class="col-md-10">
                    <input class="form-control user-input-material" type='search' placeholder='Search'
                        (keyup)='updateFilter($event)'>
                </div>
        
            </div> -->
        
            <!-- <div class="col-auto">            -->
            <!-- <button class="btn btn-md btn-primary pull-right" (click)="navigateToAddNewRole()"> -->
                    <!-- <button class="btn btn-md btn-primary pull-right"
                    (click)="openDialog(addRolesModal, { windowClass: 'modal-fill-in modal-lg animate', backdrop : 'static',keyboard : false })">
                    <span class="fa fa-plus"></span> Add New Role</button>
            </div> -->
        
        </div>
        <!-- <div class="col-md-12 p-0">
                <hr class="hr-border container-m--x mt-3 mb-3">
            </div>
        </div> -->
            
    <!-- <h6 class="card-header card-title-material">
        <h3 class="pull-left">Role List
            <button class="btn btn-md btn-outline-primary pull-right" (click)="navigateToAddNewRole()">
                <span class="fa fa-plus"></span> Add New Role</button>
        </h3>
        <div class="row">
            <div class="col-sm-6 col-md-5 col-lg-12">
                <input class="form-control user-input-material" type='text' placeholder='Search' (keyup)='updateFilter($event)'>
            </div>
        </div>
    </h6> -->
    


    <!-- </div>
</div> -->



    <!-- add New role -->
    <ng-template #addRolesModal let-c="close" let-d="dismiss">
        <div class="admin_panel modal-header">
            <h5 class="modal-title">
                Add New Role
            </h5>
            <button type="button" class="close" (click)="d('Cross click')">&times;</button>
        </div>

        <div class="modal-body">
                <h6 class="modal-title pb-3"> Enter the Role Information </h6>

            <form [formGroup]="addRole" (ngSubmit)="addNewRole(addRole.value)">
                <div class="form-row">
                    <div class="form-group col-md-6">
                        <label class="form-label">Role</label>

                        <span class="ml-2  "
                            placement="top" ngbTooltip="Select Roles">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>

                        <input [formControl]="addRole.controls['role']" name="role" type="text"
                            class="form-control" placeholder="Role"
                            [ngClass]="{'is-invalid':!addRole.controls['role'].valid && addRole.controls['role'].touched}">
                        <div *ngIf="addRole.controls['role'].hasError('required') && addRole.controls['role'].touched"
                            class="invalid-feedback">You must include a Role.</div>
                    </div>
                    <div class="form-group col-md-6">
                        <label class="form-label">Description</label>
                        <span class="ml-2  "
                            placement="top" ngbTooltip="Add Description">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                        </span>
                        <input [formControl]="addRole.controls['description']" name="description" type="text"
                            class="form-control" placeholder="Description"
                            [ngClass]="{'is-invalid':!addRole.controls['description'].valid && addRole.controls['description'].touched}">
                        <div *ngIf="addRole.controls['description'].hasError('required') && addRole.controls['description'].touched"
                            class="invalid-feedback">You must include a Description.</div>
                    </div>
                    <div class="form-group col-md-6">
                        <label class="form-label">Data Source</label>
                        <span class="ml-2  "
                            placement="top" ngbTooltip="Select Data Source">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                    </span>
                        <ng-select style="color:#a4a4a4;" [formControl]="addRole.controls['entities']"
                            placeholder="Select Data Source" [multiple]="true" [options]="entitiesList"
                            [(ngModel)]="selEntities"
                            [ngClass]="!addRole.controls['entities'].valid && addRole.controls['entities'].touched?'is-invalid ng-select-info':'ng-select-info'">
                        </ng-select>
                        <div *ngIf="addRole.controls['entities'].hasError('required') && addRole.controls['entities'].touched"
                            class="invalid-feedback">You must include a Entity.</div>
                    </div>
                </div>
                <hr />
                <button type="submit"
                    class="btn btn-primary btn-material float-right" [disabled]="!addRole.valid || isloading">Create Role</button>
                <button class="btn btn-default float-right  mr-1" (click)="d('Cross click')">Cancel</button>
            </form>
        </div>
    </ng-template>
    <!-- add New role -->


    <!-- add edit role -->
    <ng-template #editModal let-c="close" let-d="dismiss">
        <div class="admin_panel modal-header">
            <h5 class="modal-title">
                Edit Role
            </h5>
            <button type="button" class="close" (click)="d('Cross click')">&times;</button>
        </div>
        <div class="modal-body">
                <h6 class="modal-title pb-3"> Enter the Role Information </h6>
                <form [formGroup]="editRole" (ngSubmit)="fneditRole(editRole.value)">
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label class="form-label">Role</label>
                                <span class="ml-2  " placement="top"
                                        ngbTooltip="Include Role">
                                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                                </span>
                                <input [formControl]="editRole.controls['role']" [(ngModel)]="roleservice.role" name="role" type="text" class="form-control" placeholder="Role" [ngClass]="{'is-invalid':!editRole.controls['role'].valid && editRole.controls['role'].touched}">
                                <div *ngIf="editRole.controls['role'].hasError('required') && editRole.controls['role'].touched" class="invalid-feedback">You must include a Role.</div>
                                </div>
                            <div class="form-group col-md-6">
                                <label class="form-label">Description</label>
                                <span class="ml-2  " placement="top"
                                        ngbTooltip="Type Description">
                                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                                </span>
                                <input [formControl]="editRole.controls['description']" [(ngModel)]="roleservice.description" name="description" type="text" class="form-control" placeholder="Description" [ngClass]="{'is-invalid':!editRole.controls['description'].valid && editRole.controls['description'].touched}">
                                <div *ngIf="editRole.controls['description'].hasError('required') && editRole.controls['description'].touched" class="invalid-feedback">You must include a Description.</div>
                            </div>
                            <div class="form-group col-md-6">
                                <label class="form-label">Data Source</label>
                                <span class="ml-2  " placement="top"
                                        ngbTooltip="Add Data Source">
                                        <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                                </span>
                                <ng-select style="color:#a4a4a4;" [formControl]="editRole.controls['entities']" [multiple]="true" placeholder="Select Data Source" [options]="entitiesList" [(ngModel)]="selEntities" [ngClass]="!editRole.controls['entities'].valid && editRole.controls['entities'].touched?'is-invalid ng-select-info':'ng-select-info'"></ng-select>
                                <div *ngIf="editRole.controls['entities'].hasError('required') && editRole.controls['entities'].touched" class="invalid-feedback">You must include a Data Source.</div>      
                            </div>
                            <input [formControl]="editRole.controls['old_role']" [(ngModel)]="old_role" name="old_role" type="hidden" class="form-control" placeholder="Old Role">
                        </div>
                        <hr/>
                        <button type="submit" class="btn btn-primary btn-material float-right" [disabled]="!editRole.valid || isloading">Apply</button>
                        <button class="btn btn-default float-right mr-1" (click)="d('Cross click')">Cancel</button>
                    </form>
            <ngb-alert [type]="alertType" (click)="isAlert=false" *ngIf="isAlert">{{alertMessage}}</ngb-alert>
        </div>
        <!-- <div class="card bg-success">
    <div class="card-body">
        <h6>User added successfully</h6>
    </div>
</div> -->


    </ng-template>
    <ng-template #deleteModal let-c="close" let-d="dismiss">
        <div class="modal-header">
            <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
                <span class="font-weight-light">Confirmation</span>
            </h2>
    
            <button type="button" class="close" (click)="d('Cross click')">&times;</button>
        </div>
    
        <div class="modal-body">
            <!-- <h3>Are you sure?</h3> -->
            <p class="mb-0 unpin-text">Do you want to delete? {{old_role}}</p>
        </div>
    
        <div class="modal-footer">
            <button type="button" class="btn btn-primary btn-material"
                (click)="delete(old_role, description,entities);c('Close click')">Yes, delete it!</button>
            <button type="button" class="btn btn-default" (click)="c('Close click')">Cancel</button>
        </div>
        <!-- <div class="card bg-success">
    <div class="card-body">
        <h6>User added successfully</h6>
    </div>
</div> -->


    </ng-template>
    <!-- add edit role -->
    <div *blockUI="'global-loader'; template: blockTemplate"></div>
    <ng-template #blockTemplate>
        <div class="block-ui-template">
            <div class="app-splash-screen ">
                <div class="new-app-splash-screen-content text-center">
                    <img src="../../assets/img/hx-loader-logo.svg" class="loader-svg">
                    <span class="loading-text-material">
                    </span>
                </div>
            </div>
        </div>
    </ng-template>